#include "tt1.h"



int count = 0;
int LIntBuf[RLENGTH],RIntBuf[RLENGTH];  // Internal buffers for left and right channels for Read DMA
int *RdLptr, *RdRptr;  // Read pointers for external buffer
int *RdptrInit, *WrptrTemp; // two variables that need to be updated to point to next read and write pointers

// Place the audio processing algorith here. The input and output are given
// as unsigned integer pointers.
void processBlock(int *block_ptr)
{
int *TrLptr,*TrRptr,*ReLptr,*ReRptr;
int *LBlockptr, *RBlockptr;

  CYCLE_COUNT_START(count );
    
    //Clear the Block Ready Semaphore
    blockReady = 0;
    
    //Set the Processing Active Semaphore before starting processing
    isProcessing = 1;
    
  
    TrLptr = block_ptr;  // Left pointer for internal buffer for Transmit (write)DMA
    TrRptr = block_ptr + 1; //Right pointer for internal buffer for Transmit (write)DMA
    
    ReLptr = LIntBuf;   // Left pointer for internal buffer for Receive (Read) DMA
    ReRptr = RIntBuf;   // Right pointer for internal buffer for Receive (Read) DMA
    
    
    
    WriteDMA(TrLptr,WrLptr,TestL,LBUF); // Left channel write DMA
    WrLptr = WrptrTemp; //Left pointer for external buffer for next write DMA 
    RdLptr = RdptrInit; //Left pointer for external buffer for next Read DMA 
    
    WriteDMA(TrRptr,WrRptr,TestR,RBUF);
    WrRptr = WrptrTemp; //Right pointer for external buffer for next write DMA 
    RdRptr = RdptrInit; //Right pointer for external buffer for nextRead DMA 
    
    ReadDMA(ReLptr,RdLptr,TestL,LBUF); // Left channel Read DMA
    
   ReadDMA(ReRptr,RdRptr,TestR,RBUF); // Right channel Read DMA 
   
    LBlockptr = block_ptr;
    RBlockptr = block_ptr + 1;
    
    DelayProcess(LBlockptr, LIntBuf);
    DelayProcess(RBlockptr, RIntBuf); 
 
  CYCLE_COUNT_STOP( count );
    

    
    //Clear the Processing Active Semaphore after processing is complete
    isProcessing = 0;
}
