#include "tt1.h"


#pragma section("dm_delay",DMAONLY) 
int LBUF[LENGTH];// Left circular buffer
#pragma section("dm_delay",DMAONLY) 
int RBUF[LENGTH];// Right circular buffer
int *LBUFptr,*RBUFptr,*WrLptr,*WrRptr; // Pointers for left and right buffers in external memory
int *TestL , *TestR; //  pointers to test for circular buffer wrapping in DMAs

void InitBuf() // initialization buffer for both left and right channels
{
	
LBUFptr = LBUF;  // pointing to the Left buffer in external memory
WrLptr = LBUFptr+3; // Initial DMA write pointer for left buffer
TestL = LBUFptr + (((NUM_SAMPLES/2)*4)-1);  // test for left DMA 
RBUFptr = RBUF; // pointing to the Right buffer in external memory
WrRptr = RBUFptr+3; // Initial DMA write pointer for Right buffer
TestR  = RBUFptr + (((NUM_SAMPLES/2)*4)-1); // test for Right DMA
}
























 	